diff --git a/base/deploy/src/scriptlets/pkihelper.py b/base/deploy/src/scriptlets/pkihelper.py
index 95b5bf0..b04af2d 100644
--- a/base/deploy/src/scriptlets/pkihelper.py
+++ b/base/deploy/src/scriptlets/pkihelper.py
@@ -1026,6 +1290,347 @@ class war:
         return
 
 
+# PKI Deployment Password Class
+class password:
+    def create_password_conf(self, path, overwrite_flag=False):
+        try:
+            if not config.pki_dry_run_flag:
+                if os.path.exists(path):
+                    if overwrite_flag:
+                        config.pki_log.info(
+                            log.PKIHELPER_PASSWORD_CONF_1, path,
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        # overwrite the existing 'password.conf' file
+                        with open(path, "wt") as fd:
+                            if master['pki_subsystem'] in\
+                               config.PKI_APACHE_SUBSYSTEMS:
+                                fd.write("internal" + ":" +\
+                                         str(master['pki_pin']))
+                            else:
+                                fd.write("internal" + "=" +\
+                                         str(master['pki_pin']))
+                        fd.closed
+                else:
+                    config.pki_log.info(log.PKIHELPER_PASSWORD_CONF_1, path,
+                                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    # create a new 'password.conf' file
+                    with open(path, "wt") as fd:
+                        if master['pki_subsystem'] in\
+                           config.PKI_APACHE_SUBSYSTEMS:
+                            fd.write("internal" + ":" +\
+                                     str(master['pki_pin']))
+                        else:
+                            fd.write("internal" + "=" +\
+                                     str(master['pki_pin']))
+                    fd.closed
+            else:
+                if not os.path.exists(path) or overwrite_flag:
+                    config.pki_log.info(log.PKIHELPER_PASSWORD_CONF_1, path,
+                                        extra=config.PKI_INDENTATION_LEVEL_2)
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        return
+
+
+# PKI Deployment NSS 'certutil' Class
+class certutil:
+    def create_security_databases(self, path, password_file=None, prefix=None,
+                                  critical_failure=True):
+        try:
+            # Compose this "certutil" command
+            command = "certutil" + " " + "-N"
+            #   Provide a path to the NSS security databases
+            if path:
+                command = command + " " + "-d" + " " + path
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_PATH,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            if password_file != None:
+                command = command + " " + "-f" + " " + password_file
+            if prefix != None:
+                command = command + " " + "-P" + " " + prefix
+            if not config.pki_dry_run_flag:
+                if not os.path.exists(path):
+                    config.pki_log.error(
+                        log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, path,
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+                if os.path.exists(master['pki_cert_database']) or\
+                   os.path.exists(master['pki_key_database']) or\
+                   os.path.exists(master['pki_secmod_database']):
+                    # Simply notify user that the security databases exist
+                    config.pki_log.info(
+                        log.PKI_SECURITY_DATABASES_ALREADY_EXIST_3,
+                        master['pki_cert_database'],
+                        master['pki_key_database'],
+                        master['pki_secmod_database'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                else:
+                    if password_file != None:
+                        if not os.path.exists(password_file) or\
+                           not os.path.isfile(password_file):
+                            config.pki_log.error(
+                                log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                                password_file,
+                                extra=config.PKI_INDENTATION_LEVEL_2)
+                            sys.exit(1)
+                    # Display this "certutil" command
+                    config.pki_log.info(
+                        log.PKIHELPER_CREATE_SECURITY_DATABASES_1,
+                        command,
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    # Execute this "certutil" command
+                    subprocess.call(command, shell=True)
+            else:
+                if os.path.exists(master['pki_cert_database']) or\
+                   os.path.exists(master['pki_key_database']) or\
+                   os.path.exists(master['pki_secmod_database']):
+                    # Simply notify user that the security databases exist
+                    config.pki_log.info(
+                        log.PKI_SECURITY_DATABASES_ALREADY_EXIST_3,
+                        master['pki_cert_database'],
+                        master['pki_key_database'],
+                        master['pki_secmod_database'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                else:
+                    # Display this "certutil" command
+                    config.pki_log.info(
+                        log.PKIHELPER_CREATE_SECURITY_DATABASES_1,
+                        command,
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+        except subprocess.CalledProcessError as exc:
+            config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        return
+
+    def verify_certificate_exists(self, path, token, nickname,
+                                  password_file=None):
+        rv = 0
+        try:
+            # Compose this "certutil" command
+            command = "certutil" + " " + "-L"
+            #   Provide a path to the NSS security databases
+            if path:
+                command = command + " " + "-d" + " " + path
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_PATH,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   Specify the 'token'
+            if token:
+                command = command + " " + "-h" + " " + "'" + token + "'"
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_TOKEN,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   Specify the nickname of this self-signed certificate
+            if nickname:
+                command = command + " " + "-n" + " " + "'" + nickname + "'"
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_NICKNAME,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   OPTIONALLY specify a password file
+            if password_file != None:
+                command = command + " " + "-f" + " " + password_file
+            #   Always execute this command silently
+                command = command + " > /dev/null 2>&1"
+            if not config.pki_dry_run_flag:
+                if not os.path.exists(path):
+                    config.pki_log.error(
+                        log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, path,
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+                if not os.path.exists(master['pki_cert_database']) or\
+                   not os.path.exists(master['pki_key_database']) or\
+                   not os.path.exists(master['pki_secmod_database']):
+                    # NSS security databases MUST exist!
+                    config.pki_log.error(
+                        log.PKI_SECURITY_DATABASES_DO_NOT_EXIST_3,
+                        master['pki_cert_database'],
+                        master['pki_key_database'],
+                        master['pki_secmod_database'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+                if password_file != None:
+                    if not os.path.exists(password_file) or\
+                       not os.path.isfile(password_file):
+                        config.pki_log.error(
+                            log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                            password_file,
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        sys.exit(1)
+            else:
+                # Check for first time through as dry_run
+                if not os.path.exists(master['pki_cert_database']) or\
+                   not os.path.exists(master['pki_key_database']) or\
+                   not os.path.exists(master['pki_secmod_database']):
+                    return False
+            # Execute this "certutil" command
+            subprocess.check_call(command, shell=True)
+        except subprocess.CalledProcessError as exc:
+            return False
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        return True
+
+    def generate_self_signed_certificate(self, path, token, nickname,
+                                         subject, serial_number,
+                                         validity_period, issuer_name,
+                                         trustargs, noise_file,
+                                         password_file=None,
+                                         critical_failure=True):
+        try:
+            # Compose this "certutil" command
+            command = "certutil" + " " + "-S"
+            #   Provide a path to the NSS security databases
+            if path:
+                command = command + " " + "-d" + " " + path
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_PATH,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   Specify the 'token'
+            if token:
+                command = command + " " + "-h" + " " + "'" + token + "'"
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_TOKEN,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   Specify the nickname of this self-signed certificate
+            if nickname:
+                command = command + " " + "-n" + " " + "'" + nickname + "'"
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_NICKNAME,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   Specify the subject name (RFC1485)
+            if subject:
+                command = command + " " + "-s" + " " + "'" + subject + "'"
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_SUBJECT,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   Specify the serial number
+            if serial_number != None:
+                command = command + " " + "-m" + " " + str(serial_number)
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_SERIAL_NUMBER,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   Specify the months valid
+            if validity_period != None:
+                command = command + " " + "-v" + " " + str(validity_period)
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_VALIDITY_PERIOD,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   Specify the nickname of the issuer certificate
+            if issuer_name:
+                command = command + " " + "-c" + " " +\
+                      "'" + issuer_name + "'"
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_ISSUER_NAME,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   Specify the certificate trust attributes
+            if trustargs:
+                command = command + " " + "-t" + " " + "'" + trustargs + "'"
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_TRUSTARGS,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   Specify a noise file to be used for key generation
+            if noise_file:
+                command = command + " " + "-z" + " " + noise_file
+            else:
+                config.pki_log.error(
+                    log.PKIHELPER_CERTUTIL_MISSING_NOISE_FILE,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            #   OPTIONALLY specify a password file
+            if password_file != None:
+                command = command + " " + "-f" + " " + password_file
+            #   ALWAYS self-sign this certificate
+            command = command + " " + "-x"
+            #   ALWAYS mask the command-line output of this command
+            command = command + " " + "> /dev/null 2>&1"
+            # Display this "certutil" command
+            config.pki_log.info(
+                log.PKIHELPER_CERTUTIL_SELF_SIGNED_CERTIFICATE_1, command,
+                extra=config.PKI_INDENTATION_LEVEL_2)
+            if not config.pki_dry_run_flag:
+                if not os.path.exists(path):
+                    config.pki_log.error(
+                        log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, path,
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+                if not os.path.exists(master['pki_cert_database']) or\
+                   not os.path.exists(master['pki_key_database']) or\
+                   not os.path.exists(master['pki_secmod_database']):
+                    # NSS security databases MUST exist!
+                    config.pki_log.error(
+                        log.PKI_SECURITY_DATABASES_DO_NOT_EXIST_3,
+                        master['pki_cert_database'],
+                        master['pki_key_database'],
+                        master['pki_secmod_database'],
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+                if not os.path.exists(noise_file):
+                    config.pki_log.error(
+                        log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1,
+                        noise_file,
+                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    sys.exit(1)
+                if password_file != None:
+                    if not os.path.exists(password_file) or\
+                       not os.path.isfile(password_file):
+                        config.pki_log.error(
+                            log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
+                            password_file,
+                            extra=config.PKI_INDENTATION_LEVEL_2)
+                        sys.exit(1)
+                # Execute this "certutil" command
+                subprocess.call(command, shell=True)
+        except subprocess.CalledProcessError as exc:
+            config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        return
+
+
 # PKI Deployment Helper Class Instances
 identity = identity()
 instance = instance()
@@ -1033,3 +1638,5 @@ directory = directory()
 file = file()
 symlink = symlink()
 war = war()
+password = password()
+certutil = certutil()
diff --git a/base/deploy/src/scriptlets/pkimanifest.py b/base/deploy/src/scriptlets/pkimanifest.py
index dfd18fb..4f45e4b 100644
--- a/base/deploy/src/scriptlets/pkimanifest.py
+++ b/base/deploy/src/scriptlets/pkimanifest.py
@@ -22,6 +22,12 @@
 # System Imports
 from collections import namedtuple
 import csv
+import sys
+
+
+# PKI Deployment Imports
+import pkiconfig as config
+import pkimessages as log
 
 
 # PKI Deployment Manifest Constants
diff --git a/base/deploy/src/scriptlets/pkimessages.py b/base/deploy/src/scriptlets/pkimessages.py
index 81f0ead..774b1f1 100644
--- a/base/deploy/src/scriptlets/pkimessages.py
+++ b/base/deploy/src/scriptlets/pkimessages.py
@@ -28,6 +28,10 @@ PKI_DICTIONARY_MASTER="\n"\
 "=====================================================\n"\
 "    DISPLAY CONTENTS OF PKI MASTER DICTIONARY\n"\
 "====================================================="
+PKI_DICTIONARY_SLOTS="\n"\
+"=====================================================\n"\
+"    DISPLAY CONTENTS OF PKI SLOTS DICTIONARY\n"\
+"====================================================="
 PKI_DICTIONARY_SUBSYSTEM="\n"\
 "=====================================================\n"\
 "    DISPLAY CONTENTS OF PKI SUBSYSTEM DICTIONARY\n"\
@@ -74,6 +78,14 @@ PKI_FILE_ALREADY_EXISTS_NOT_A_FILE_1 = "File '%s' already "\
 PKI_FILE_MISSING_OR_NOT_A_FILE_1 = "File '%s' is either missing "\
                                    "or is NOT a regular file!"
 PKI_FILE_NOT_A_WAR_FILE_1 = "File '%s' is NOT a war file!"
+PKI_SECURITY_DATABASES_ALREADY_EXIST_3 = "Security databases '%s', '%s', "\
+                                         "and/or '%s' already exist!"
+PKI_SECURITY_DATABASES_DO_NOT_EXIST_3 = "Security databases '%s', '%s', "\
+                                        "and/or '%s' do NOT exist!"
+PKI_SUBSYSTEM_ALREADY_EXISTS_2 = "PKI subsystem '%s' for instance '%s' "\
+                                 "already exists!"
+PKI_SUBSYSTEM_DOES_NOT_EXIST_2 = "PKI subsystem '%s' for instance '%s' "\
+                                 "does NOT exist!"
 
 PKI_IOERROR_1 = "IOError:  %s!"
 PKI_KEYERROR_1 = "KeyError:  %s!"
@@ -81,6 +93,7 @@ PKI_LARGEZIPFILE_ERROR_1 = "zipfile.LargeZipFile:  %s!"
 PKI_MANIFEST_MESSAGE_1 = "generating manifest file called '%s'"
 PKI_OSERROR_1 = "OSError:  %s!"
 PKI_SHUTIL_ERROR_1 = "shutil.Error:  %s!"
+PKI_SUBPROCESS_ERROR_1 = "subprocess.CalledProcessError:  %s!"
 PKI_SYMLINK_ALREADY_EXISTS_1 = "Symlink '%s' already exists!"
 PKI_SYMLINK_ALREADY_EXISTS_NOT_A_SYMLINK_1 = "Symlink '%s' already "\
                                              "exists BUT it is NOT a "\
@@ -108,12 +121,32 @@ PKISPAWN_END_MESSAGE_2 = "END spawning subsystem '%s' of "\
 
 
 # PKI Deployment "Helper" Messages
-PKIHELPER_APACHE_INSTANCES_2 = "instance '%s' contains '%d' Apache PKI subsystems"
+PKIHELPER_APACHE_INSTANCES_2 = "instance '%s' contains '%d' "\
+                               "Apache PKI subsystems"
+PKIHELPER_CERTUTIL_MISSING_ISSUER_NAME = "certutil:  Missing "\
+                                         "'-c issuer-name' option!"
+PKIHELPER_CERTUTIL_MISSING_NICKNAME = "certutil:  Missing "\
+                                      "'-n nickname' option!"
+PKIHELPER_CERTUTIL_MISSING_NOISE_FILE = "certutil:  Missing "\
+                                        "'-z noise-file' option!"
+PKIHELPER_CERTUTIL_MISSING_PATH = "certutil:  Missing '-d path' option!"
+PKIHELPER_CERTUTIL_MISSING_SERIAL_NUMBER = "certutil:  Missing "\
+                                           "'-m serial-number' option!"
+PKIHELPER_CERTUTIL_MISSING_SUBJECT = "certutil:  Missing '-s subject' option!"
+PKIHELPER_CERTUTIL_MISSING_TOKEN = "certutil:  Missing '-h token' option!"
+PKIHELPER_CERTUTIL_MISSING_TRUSTARGS = "certutil:  Missing "\
+                                       "'-t trustargs' option!"
+PKIHELPER_CERTUTIL_MISSING_VALIDITY_PERIOD = "certutil:  Missing "\
+                                             "'-v months-valid' option!"
+PKIHELPER_CERTUTIL_SELF_SIGNED_CERTIFICATE_1 = "executing '%s'"
 PKIHELPER_CHMOD_2 = "chmod %o %s"
 PKIHELPER_CHOWN_3 = "chown %s:%s %s"
 PKIHELPER_CHOWN_H_3 = "chown -h %s:%s %s"
+PKIHELPER_COPY_WITH_SLOT_SUBSTITUTION_2 = "copying '%s' --> '%s' "\
+                                          "with slot substitution"
 PKIHELPER_CP_P_2 = "cp -p %s %s"
 PKIHELPER_CP_RP_2 = "cp -rp %s %s"
+PKIHELPER_CREATE_SECURITY_DATABASES_1 = "executing '%s'"
 PKIHELPER_DANGLING_SYMLINK_2 = "Dangling symlink '%s'-->'%s'"
 PKIHELPER_DIRECTORY_IS_EMPTY_1 = "directory '%s' is empty"
 PKIHELPER_DIRECTORY_IS_NOT_EMPTY_1 = "directory '%s' is NOT empty"
@@ -124,16 +157,24 @@ PKIHELPER_IS_A_FILE_1 = "'%s' is a file"
 PKIHELPER_IS_A_SYMLINK_1 = "'%s' is a symlink"
 PKIHELPER_JAR_XF_C_2 = "jar -xf %s -C %s"
 PKIHELPER_LINK_S_2 = "ln -s %s %s"
+PKIHELPER_APPLY_SLOT_SUBSTITUTION_1 = "applying in-place "\
+                                      "slot substitutions on '%s'"
 PKIHELPER_MKDIR_1 = "mkdir -p %s"
 PKIHELPER_MODIFY_DIR_1 = "modifying '%s'"
 PKIHELPER_MODIFY_FILE_1 = "modifying '%s'"
 PKIHELPER_MODIFY_SYMLINK_1 = "modifying '%s'"
-PKIHELPER_PKI_SUBSYSTEM_INSTANCES_2 = "instance '%s' contains '%d' PKI subsystems"
+PKIHELPER_NOISE_FILE_2 = "generating noise file called '%s' and "\
+                         "filling it with '%d' random bytes"
+PKIHELPER_PASSWORD_CONF_1 = "generating '%s'"
+PKIHELPER_PKI_SUBSYSTEM_INSTANCES_2 = "instance '%s' contains '%d' "\
+                                      "PKI subsystems"
 PKIHELPER_RM_F_1 = "rm -f %s"
 PKIHELPER_RM_RF_1 = "rm -rf %s"
 PKIHELPER_RMDIR_1 = "rmdir %s"
 PKIHELPER_SET_MODE_1 = "setting ownerships, permissions, and acls on '%s'"
-PKIHELPER_TOMCAT_INSTANCES_2 = "instance '%s' contains '%d' Tomcat PKI subsystems"
+PKIHELPER_SLOT_SUBSTITUTION_2 = "slot substitution: '%s' ==> '%s'"
+PKIHELPER_TOMCAT_INSTANCES_2 = "instance '%s' contains '%d' "\
+                               "Tomcat PKI subsystems"
 PKIHELPER_TOUCH_1 = "touch %s"
 PKIHELPER_UID_2 = "UID of '%s' is %s"
 PKIHELPER_USER_1 = "retrieving UID for '%s' . . ."
diff --git a/base/deploy/src/scriptlets/pkiparser.py b/base/deploy/src/scriptlets/pkiparser.py
index bff4059..19c9119 100644
--- a/base/deploy/src/scriptlets/pkiparser.py
+++ b/base/deploy/src/scriptlets/pkiparser.py
@@ -24,6 +24,7 @@ import ConfigParser
 import argparse
 import logging
 import os
+import time
 
 
 # PKI Deployment Imports
@@ -171,9 +172,14 @@ def process_command_line_arguments(argv):
         # NOTE:  When performing 'pkidestroy', a configuration file must be
         #        explicitly specified if it does not use the default location
         #        and/or default configuration file name.
+        if config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS:
+            pki_web_server = "Apache"
+        elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+            pki_web_server = "Tomcat"
         config.pkideployment_cfg = config.pki_root_prefix +\
             config.PKI_DEPLOYMENT_REGISTRY_ROOT + "/" +\
             config.PKI_DEPLOYMENT_DEFAULT_INSTANCE_NAME + "/" +\
+            pki_web_server.lower() +"/" +\
             config.pki_subsystem.lower() +"/" +\
             config.PKI_DEPLOYMENT_DEFAULT_CONFIGURATION_FILE
     if not os.path.exists(config.pkideployment_cfg) or\
@@ -192,6 +198,8 @@ def read_pki_configuration_file():
     rv = 0
     try:
         parser = ConfigParser.ConfigParser()
+        # Make keys case-sensitive!
+        parser.optionxform = str
         parser.read(config.pkideployment_cfg)
         config.pki_common_dict = dict(parser._sections['Common'])
         if config.pki_subsystem == "CA":
